diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.cc ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.cc
--- ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.cc	2025-03-09 16:55:49.783372600 -0700
@@ -598,4 +772,148 @@
     });
 }
 
+void
+AdvancedEmlsrManager::SwitchMainPhyIfTxopToBeGainedByAuxPhy(uint8_t linkId,
+                                                            AcIndex aci,
+                                                            const Time& delay)
+{
+    NS_LOG_FUNCTION(this << linkId << aci << delay.As(Time::US));
+
+    if (m_auxPhyTxCapable)
+    {
+        NS_LOG_DEBUG("Nothing to do if aux PHY is TX capable");
+        return;
+    }
+
+    if (!delay.IsStrictlyPositive())
+    {
+        NS_LOG_DEBUG("Do nothing if delay is not strictly positive");
+        return;
+    }
+
+    if (GetEhtFem(linkId)->UsingOtherEmlsrLink())
+    {
+        NS_LOG_DEBUG("Do nothing because another EMLSR link is being used");
+        return;
+    }
+
+    if (!DoGetDelayUntilAccessRequest(linkId).first)
+    {
+        NS_LOG_DEBUG("Do nothing because a frame is being received on another EMLSR link");
+        return;
+    }
+
+    auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+    auto phy = GetStaMac()->GetWifiPhy(linkId);
+
+    if (!phy || phy == mainPhy)
+    {
+        NS_LOG_DEBUG("No aux PHY is operating on link " << +linkId);
+        return;
+    }
+
+    if (!RequestMainPhyToSwitch(linkId, aci, delay))
+    {
+        NS_LOG_DEBUG("Chosen not to request the main PHY to switch");
+        if (const auto untilIdle = mainPhy->GetDelayUntilIdle();
+            untilIdle.IsStrictlyPositive() && untilIdle < delay)
+        {
+            NS_LOG_DEBUG("Retrying in " << untilIdle.As(Time::US));
+            Simulator::Schedule(untilIdle,
+                                &AdvancedEmlsrManager::SwitchMainPhyIfTxopToBeGainedByAuxPhy,
+                                this,
+                                linkId,
+                                aci,
+                                delay - untilIdle);
+        }
+        return;
+    }
+
+    // switch main PHY
+
+    // use aux PHY CCA (if allowed) if the backoff has already counted down to zero on the aux PHY
+    // link when the main PHY completes the switch
+    const auto edca = GetStaMac()->GetQosTxop(aci);
+    const auto cam = GetStaMac()->GetChannelAccessManager(linkId);
+    const auto auxPhy = GetStaMac()->GetWifiPhy(linkId);
+    const auto switchDelay = mainPhy->GetChannelSwitchDelay();
+    const auto now = Simulator::Now();
+    const auto auxPhyCcaCanBeUsed =
+        m_useAuxPhyCca || (GetChannelForAuxPhy(linkId).GetTotalWidth() >=
+                           GetChannelForMainPhy(linkId).GetTotalWidth());
+    const auto backoffEndBeforeSwitch = (cam->GetBackoffEndFor(edca) - now) <= switchDelay;
+
+    if (auxPhyCcaCanBeUsed && backoffEndBeforeSwitch)
+    {
+        NS_LOG_DEBUG("Schedule CCA check at the end of main PHY switch");
+        m_ccaLastPifs = Simulator::Schedule(switchDelay, [=, this]() {
+            // check NAV and CCA only if the backoff actually counted down to zero already
+            if (cam->GetBackoffEndFor(edca) <= Simulator::Now())
+            {
+                CheckNavAndCcaLastPifs(auxPhy, linkId, edca);
+            }
+        });
+    }
+
+    Time remNav{0};
+    if (const auto mainPhyLinkId = GetStaMac()->GetLinkForPhy(mainPhy))
+    {
+        auto mainPhyNavEnd = GetStaMac()->GetChannelAccessManager(*mainPhyLinkId)->GetNavEnd();
+        remNav = Max(remNav, mainPhyNavEnd - now);
+    }
+
+    SwitchMainPhy(linkId,
+                  false,
+                  RESET_BACKOFF,
+                  DONT_REQUEST_ACCESS,
+                  EmlsrUlTxopAuxPhyNotTxCapableTrace(aci, delay, remNav));
+
+    // check expected channel access delay when switch is completed
+    Simulator::Schedule(switchDelay, [=, this]() {
+        const auto accessDelay = cam->GetBackoffEndFor(edca) - Simulator::Now();
+
+        if (auxPhyCcaCanBeUsed && backoffEndBeforeSwitch && accessDelay.IsNegative())
+        {
+            // backoff already counted down to zero and we used aux PHY CCA
+            return;
+        }
+
+        const auto pifs = GetStaMac()->GetWifiPhy(linkId)->GetPifs();
+
+        // if the remaining backoff time is shorter than PIFS when the main PHY completes the
+        // switch, we need to schedule a CCA check a PIFS after the end of the main PHY switch
+        if (accessDelay <= pifs)
+        {
+            // use main PHY CCA in the last PIFS interval after main PHY switch end
+            NS_LOG_DEBUG("Schedule CCA check a PIFS after the end of main PHY switch");
+            m_ccaLastPifs = Simulator::Schedule(pifs,
+                                                &AdvancedEmlsrManager::CheckNavAndCcaLastPifs,
+                                                this,
+                                                mainPhy,
+                                                linkId,
+                                                edca);
+        }
+        else if (!GetExpectedAccessWithinDelay(linkId,
+                                               accessDelay + m_switchMainPhyBackDelay +
+                                                   mainPhy->GetChannelSwitchDelay()))
+        {
+            NS_LOG_DEBUG("No AC is expected to get backoff soon, switch main PHY back");
+            SwitchMainPhyBackDelayExpired(linkId);
+        }
+        else
+        {
+            // the main PHY must stay for some time on this link to check if it gets channel
+            // access. The timer is stopped if a DL or UL TXOP is started. When the timer
+            // expires, the main PHY switches back to the preferred link if SwitchAuxPhy is
+            // false
+            m_switchMainPhyBackEvent.Cancel();
+            m_switchMainPhyBackEvent =
+                Simulator::Schedule(accessDelay + m_switchMainPhyBackDelay,
+                                    &AdvancedEmlsrManager::SwitchMainPhyBackDelayExpired,
+                                    this,
+                                    linkId);
+        }
+    });
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.h ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -11,11 +11,15 @@
 
 #include "default-emlsr-manager.h"
 
+#include <memory>
+
 namespace ns3
 {
 
+class WifiPhyListener;
+
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * AdvancedEmlsrManager is an advanced EMLSR manager.
  */
@@ -23,29 +27,38 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     AdvancedEmlsrManager();
     ~AdvancedEmlsrManager() override;
 
+    /**
+     * This method is called by the PHY listener attached to the main PHY when a switch main PHY
+     * back timer is started to notify of events that may delay the channel access for the main
+     * PHY on the current link. If the expected channel access is beyond the end of the switch
+     * main PHY timer expiration plus a channel switch delay, the timer is stopped immediately.
+     */
+    void InterruptSwitchMainPhyBackTimerIfNeeded();
+
   protected:
     void DoDispose() override;
     void DoSetWifiMac(Ptr<StaWifiMac> mac) override;
     std::pair<bool, Time> DoGetDelayUntilAccessRequest(uint8_t linkId) override;
     std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) override;
     void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) override;
+    void NotifyEmlsrModeChanged() override;
 
     /**
      * Possibly take actions when notified of the MAC header of the MPDU being received by the
      * given PHY.
      *
-     * \param phy the given PHY
-     * \param macHdr the MAC header of the MPDU being received
-     * \param txVector the TXVECTOR used to transmit the PSDU
-     * \param psduDuration the remaining duration of the PSDU
+     * @param phy the given PHY
+     * @param macHdr the MAC header of the MPDU being received
+     * @param txVector the TXVECTOR used to transmit the PSDU
+     * @param psduDuration the remaining duration of the PSDU
      */
     void ReceivedMacHdr(Ptr<WifiPhy> phy,
                         const WifiMacHeader& macHdr,
@@ -58,29 +71,52 @@
      * intended to be used when the main PHY switches channel to start an UL TXOP on a link where
      * channel access was obtained by a non-TX capable aux PHY.
      *
-     * \param phy the PHY that performed CCA in the last PIFS interval
-     * \param linkId the ID of the given link
-     * \param edca the given EDCAF
+     * @param phy the PHY that performed CCA in the last PIFS interval
+     * @param linkId the ID of the given link
+     * @param edca the given EDCAF
      */
     void CheckNavAndCcaLastPifs(Ptr<WifiPhy> phy, uint8_t linkId, Ptr<QosTxop> edca);
 
     /**
      * Determine whether the main PHY shall be requested to switch to the link of an aux PHY that
-     * has gained channel access through the given AC but it is not TX capable.
+     * is expected to gain channel access through the given AC in the given delay but it is not
+     * TX capable.
+     *
+     * @param linkId the ID of the link on which the aux PHY is operating
+     * @param aci the index of the given AC
+     * @param delay the delay after which the given AC is expected to gain channel access. Zero
+     *              indicates that channel access has been actually gained
+     * @return whether the main PHY shall be requested to switch to the link of the aux PHY
+     */
+    bool RequestMainPhyToSwitch(uint8_t linkId, AcIndex aci, const Time& delay);
+
+    /**
+     * This method is called when the given AC of the EMLSR client is expected to get channel
+     * access in the given delay on the given link, on which an aux PHY that is not TX capable
+     * is operating. This method has to decide whether to request the main PHY to switch to the
+     * given link to try to start a TXOP.
      *
-     * \param linkId the ID of the link on which the aux PHY is operating
-     * \param aci the index of the given AC
-     * \return whether the main PHY shall be requested to switch to the link of the aux PHY
+     * @param linkId the ID of the given link
+     * @param aci the index of the given AC
+     * @param delay the delay after which the given AC is expected to gain channel access
      */
-    bool RequestMainPhyToSwitch(uint8_t linkId, AcIndex aci);
+    void SwitchMainPhyIfTxopToBeGainedByAuxPhy(uint8_t linkId, AcIndex aci, const Time& delay);
+
+    /**
+     * This method is called when the switch main PHY back delay timer (which is started when the
+     * main PHY switches to the link of an aux PHY that does not switch and is not TX capable)
+     * expires and decides whether to delay the request to switch the main PHY back to the preferred
+     * link or to execute it immediately.
+     *
+     * @param linkId the ID of the link that the main PHY is leaving
+     */
+    void SwitchMainPhyBackDelayExpired(uint8_t linkId);
 
   private:
     void DoNotifyTxopEnd(uint8_t linkId) override;
     void DoNotifyIcfReceived(uint8_t linkId) override;
     void DoNotifyUlTxopStart(uint8_t linkId) override;
 
-    bool m_useNotifiedMacHdr;      //!< whether to use the information about the MAC header of
-                                   //!< the MPDU being received (if notified by the PHY)
     bool m_allowUlTxopInRx;        //!< whether a (main or aux) PHY is allowed to start an UL
                                    //!< TXOP if another PHY is receiving a PPDU
     bool m_interruptSwitching;     //!< whether a main PHY switching can be interrupted to start
@@ -98,6 +134,31 @@
     EventId m_switchMainPhyBackEvent; //!< event scheduled in case of non-TX capable aux PHY when
                                       //!< medium is sensed busy during the PIFS interval
                                       //!< preceding/following the main PHY switch end
+    std::shared_ptr<WifiPhyListener>
+        m_phyListener; //!< PHY listener connected to the main PHY while operating on the link of
+                       //!< an aux PHY that is not TX capable
+};
+
+/**
+ * Struct to trace that main PHY switched to leave a link on which an aux PHY was expected to gain
+ * a TXOP but the main PHY did not manage to gain a TXOP in the pre-configured amount of time.
+ */
+struct EmlsrSwitchMainPhyBackTrace : public EmlsrMainPhySwitchTraceImpl<EmlsrSwitchMainPhyBackTrace>
+{
+    static constexpr std::string_view m_name = "TxopNotGainedOnAuxPhyLink"; //!< trace name
+
+    bool nothingToTx; //!< if true, the main PHY managed to gain a TXOP but had nothing to transmit
+
+    /**
+     * Constructor provided because this struct is not an aggregate (it has a base struct), hence
+     * we cannot use designated initializers.
+     *
+     * @param nothing the value for the nothingToTx field
+     */
+    EmlsrSwitchMainPhyBackTrace(bool nothing)
+        : nothingToTx(nothing)
+    {
+    }
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/ap-emlsr-manager.h ns-3.44/src/wifi/model/eht/ap-emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/ap-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/ap-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -22,7 +22,7 @@
 class WifiTxVector;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * ApEmlsrManager is an abstract base class defining the API that EHT AP MLDs with
  * EMLSR activated can use to handle the operations on the EMLSR links of EMLSR clients
@@ -31,8 +31,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     ApEmlsrManager();
@@ -41,23 +41,23 @@
     /**
      * Set the wifi MAC. Note that it must be the MAC of an EHT AP MLD.
      *
-     * \param mac the wifi MAC
+     * @param mac the wifi MAC
      */
     void SetWifiMac(Ptr<ApWifiMac> mac);
 
     /**
      * This method is called when the reception of a PSDU succeeds on the given link.
      *
-     * \param linkId the ID of the given link
-     * \param psdu the PSDU whose reception succeeded
+     * @param linkId the ID of the given link
+     * @param psdu the PSDU whose reception succeeded
      */
     virtual void NotifyPsduRxOk(uint8_t linkId, Ptr<const WifiPsdu> psdu);
 
     /**
      * This method is called when the reception of a PSDU fails on the given link.
      *
-     * \param linkId the ID of the given link
-     * \param psdu the PSDU whose reception failed
+     * @param linkId the ID of the given link
+     * @param psdu the PSDU whose reception failed
      */
     virtual void NotifyPsduRxError(uint8_t linkId, Ptr<const WifiPsdu> psdu);
 
@@ -65,17 +65,17 @@
      * This method is intended to be called when the AP MLD starts transmitting an SU frame that
      * is not addressed to EMLSR clients that were previously involved in the ongoing DL TXOP.
      *
-     * \param psdu the PSDU being transmitted
-     * \param txVector the TXVECTOR used to transmit the PSDU
-     * \param band the PHY band in which the PSDU is being transmitted
-     * \return the delay after which the AP MLD starts the transition delay for the EMLSR client
+     * @param psdu the PSDU being transmitted
+     * @param txVector the TXVECTOR used to transmit the PSDU
+     * @param band the PHY band in which the PSDU is being transmitted
+     * @return the delay after which the AP MLD starts the transition delay for the EMLSR client
      */
     virtual Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
                                              const WifiTxVector& txVector,
                                              WifiPhyBand band) = 0;
 
     /**
-     * \return whether the AP MLD shall double the CW upon CTS timeout after an MU-RTS in case
+     * @return whether the AP MLD shall double the CW upon CTS timeout after an MU-RTS in case
      *         all the clients solicited by the MU-RTS are EMLSR clients that have sent (or
      *         are sending) a frame to the AP
      */
@@ -87,18 +87,18 @@
     /**
      * Allow subclasses to take actions when the MAC is set.
      *
-     * \param mac the wifi MAC
+     * @param mac the wifi MAC
      */
     virtual void DoSetWifiMac(Ptr<ApWifiMac> mac);
 
     /**
-     * \return the MAC of the AP MLD managed by this AP EMLSR Manager.
+     * @return the MAC of the AP MLD managed by this AP EMLSR Manager.
      */
     Ptr<ApWifiMac> GetApMac() const;
 
     /**
-     * \param linkId the ID of the given link
-     * \return the EHT FrameExchangeManager attached to the AP operating on the given link
+     * @param linkId the ID of the given link
+     * @return the EHT FrameExchangeManager attached to the AP operating on the given link
      */
     Ptr<EhtFrameExchangeManager> GetEhtFem(uint8_t linkId) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/common-info-basic-mle.cc ns-3.44/src/wifi/model/eht/common-info-basic-mle.cc
--- ns-3.43/src/wifi/model/eht/common-info-basic-mle.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/eht/common-info-basic-mle.cc	2025-03-09 16:55:49.783372600 -0700
@@ -0,0 +1,305 @@
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "common-info-basic-mle.h"
+
+#include "ns3/address-utils.h"
+
+namespace ns3
+{
+
+uint16_t
+CommonInfoBasicMle::GetPresenceBitmap() const
+{
+    // see Sec. 9.4.2.312.2.1 of 802.11be D1.5
+    return (m_linkIdInfo.has_value() ? 0x0001 : 0x0) |
+           (m_bssParamsChangeCount.has_value() ? 0x0002 : 0x0) |
+           (m_mediumSyncDelayInfo.has_value() ? 0x0004 : 0x0) |
+           (m_emlCapabilities.has_value() ? 0x0008 : 0x0) |
+           (m_mldCapabilities.has_value() ? 0x0010 : 0x0) | (m_apMldId.has_value() ? 0x0020 : 0x0) |
+           (m_extMldCapabilities.has_value() ? 0x0040 : 0x0);
+}
+
+uint8_t
+CommonInfoBasicMle::GetSize() const
+{
+    uint8_t ret = 7; // Common Info Length (1) + MLD MAC Address (6)
+    ret += (m_linkIdInfo.has_value() ? 1 : 0);
+    ret += (m_bssParamsChangeCount.has_value() ? 1 : 0);
+    ret += (m_mediumSyncDelayInfo.has_value() ? 2 : 0);
+    ret += (m_emlCapabilities.has_value() ? 2 : 0);
+    ret += (m_mldCapabilities.has_value() ? 2 : 0);
+    ret += (m_apMldId.has_value() ? 1 : 0);
+    ret += (m_extMldCapabilities.has_value() ? 2 : 0);
+    return ret;
+}
+
+void
+CommonInfoBasicMle::Serialize(Buffer::Iterator& start) const
+{
+    start.WriteU8(GetSize()); // Common Info Length
+    WriteTo(start, m_mldMacAddress);
+    if (m_linkIdInfo.has_value())
+    {
+        start.WriteU8(*m_linkIdInfo & 0x0f);
+    }
+    if (m_bssParamsChangeCount.has_value())
+    {
+        start.WriteU8(*m_bssParamsChangeCount);
+    }
+    if (m_mediumSyncDelayInfo.has_value())
+    {
+        start.WriteU8(m_mediumSyncDelayInfo->mediumSyncDuration);
+        uint8_t val = m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold |
+                      (m_mediumSyncDelayInfo->mediumSyncMaxNTxops << 4);
+        start.WriteU8(val);
+    }
+    if (m_emlCapabilities.has_value())
+    {
+        uint16_t val =
+            m_emlCapabilities->emlsrSupport | (m_emlCapabilities->emlsrPaddingDelay << 1) |
+            (m_emlCapabilities->emlsrTransitionDelay << 4) |
+            (m_emlCapabilities->emlmrSupport << 7) | (m_emlCapabilities->emlmrDelay << 8) |
+            (m_emlCapabilities->transitionTimeout << 11);
+        start.WriteHtolsbU16(val);
+    }
+    if (m_mldCapabilities.has_value())
+    {
+        uint16_t val =
+            m_mldCapabilities->maxNSimultaneousLinks | (m_mldCapabilities->srsSupport << 4) |
+            (m_mldCapabilities->tidToLinkMappingSupport << 5) |
+            (m_mldCapabilities->freqSepForStrApMld << 7) | (m_mldCapabilities->aarSupport << 12);
+        start.WriteHtolsbU16(val);
+    }
+    if (m_apMldId.has_value())
+    {
+        start.WriteU8(*m_apMldId);
+    }
+    if (m_extMldCapabilities.has_value())
+    {
+        uint16_t val = m_extMldCapabilities->opParamUpdateSupp |
+                       (m_extMldCapabilities->recommMaxSimulLinks << 1) |
+                       (m_extMldCapabilities->nstrStatusUpdateSupp << 5);
+        start.WriteHtolsbU16(val);
+    }
+}
+
+uint8_t
+CommonInfoBasicMle::Deserialize(Buffer::Iterator start, uint16_t presence)
+{
+    Buffer::Iterator i = start;
+
+    uint8_t length = i.ReadU8();
+    ReadFrom(i, m_mldMacAddress);
+    uint8_t count = 7;
+
+    if ((presence & 0x0001) != 0)
+    {
+        m_linkIdInfo = i.ReadU8() & 0x0f;
+        count++;
+    }
+    if ((presence & 0x0002) != 0)
+    {
+        m_bssParamsChangeCount = i.ReadU8();
+        count++;
+    }
+    if ((presence & 0x0004) != 0)
+    {
+        m_mediumSyncDelayInfo = MediumSyncDelayInfo();
+        m_mediumSyncDelayInfo->mediumSyncDuration = i.ReadU8();
+        uint8_t val = i.ReadU8();
+        m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold = val & 0x0f;
+        m_mediumSyncDelayInfo->mediumSyncMaxNTxops = (val >> 4) & 0x0f;
+        count += 2;
+    }
+    if ((presence & 0x0008) != 0)
+    {
+        m_emlCapabilities = EmlCapabilities();
+        uint16_t val = i.ReadLsbtohU16();
+        m_emlCapabilities->emlsrSupport = val & 0x0001;
+        m_emlCapabilities->emlsrPaddingDelay = (val >> 1) & 0x0007;
+        m_emlCapabilities->emlsrTransitionDelay = (val >> 4) & 0x0007;
+        m_emlCapabilities->emlmrSupport = (val >> 7) & 0x0001;
+        m_emlCapabilities->emlmrDelay = (val >> 8) & 0x0007;
+        m_emlCapabilities->transitionTimeout = (val >> 11) & 0x000f;
+        count += 2;
+    }
+    if ((presence & 0x0010) != 0)
+    {
+        m_mldCapabilities = MldCapabilities();
+        uint16_t val = i.ReadLsbtohU16();
+        m_mldCapabilities->maxNSimultaneousLinks = val & 0x000f;
+        m_mldCapabilities->srsSupport = (val >> 4) & 0x0001;
+        m_mldCapabilities->tidToLinkMappingSupport = (val >> 5) & 0x0003;
+        m_mldCapabilities->freqSepForStrApMld = (val >> 7) & 0x001f;
+        m_mldCapabilities->aarSupport = (val >> 12) & 0x0001;
+        count += 2;
+    }
+    if ((presence & 0x0020) != 0)
+    {
+        m_apMldId = i.ReadU8();
+        count++;
+    }
+    if ((presence & 0x0040) != 0)
+    {
+        m_extMldCapabilities = ExtMldCapabilities();
+        auto val = i.ReadLsbtohU16();
+        m_extMldCapabilities->opParamUpdateSupp = val & 0x0001;
+        m_extMldCapabilities->recommMaxSimulLinks = (val >> 1) & 0x000f;
+        m_extMldCapabilities->nstrStatusUpdateSupp = (val >> 5) & 0x0001;
+        count += 2;
+    }
+
+    NS_ABORT_MSG_IF(count != length,
+                    "Common Info Length (" << +length
+                                           << ") differs "
+                                              "from actual number of bytes read ("
+                                           << +count << ")");
+    return count;
+}
+
+uint8_t
+CommonInfoBasicMle::EncodeEmlsrPaddingDelay(Time delay)
+{
+    auto delayUs = delay.GetMicroSeconds();
+
+    if (delayUs == 0)
+    {
+        return 0;
+    }
+
+    for (uint8_t i = 1; i <= 4; i++)
+    {
+        if (1 << (i + 4) == delayUs)
+        {
+            return i;
+        }
+    }
+
+    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
+    return 0;
+}
+
+Time
+CommonInfoBasicMle::DecodeEmlsrPaddingDelay(uint8_t value)
+{
+    NS_ABORT_MSG_IF(value > 4, "Value not allowed (" << +value << ")");
+    if (value == 0)
+    {
+        return MicroSeconds(0);
+    }
+    return MicroSeconds(1 << (4 + value));
+}
+
+uint8_t
+CommonInfoBasicMle::EncodeEmlsrTransitionDelay(Time delay)
+{
+    auto delayUs = delay.GetMicroSeconds();
+
+    if (delayUs == 0)
+    {
+        return 0;
+    }
+
+    for (uint8_t i = 1; i <= 5; i++)
+    {
+        if (1 << (i + 3) == delayUs)
+        {
+            return i;
+        }
+    }
+
+    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
+    return 0;
+}
+
+Time
+CommonInfoBasicMle::DecodeEmlsrTransitionDelay(uint8_t value)
+{
+    NS_ABORT_MSG_IF(value > 5, "Value not allowed (" << +value << ")");
+    if (value == 0)
+    {
+        return MicroSeconds(0);
+    }
+    return MicroSeconds(1 << (3 + value));
+}
+
+void
+CommonInfoBasicMle::SetMediumSyncDelayTimer(Time delay)
+{
+    int64_t delayUs = delay.GetMicroSeconds();
+    NS_ABORT_MSG_IF(delayUs % 32 != 0, "Delay must be a multiple of 32 microseconds");
+    delayUs /= 32;
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+    m_mediumSyncDelayInfo->mediumSyncDuration = (delayUs & 0xff);
+}
+
+Time
+CommonInfoBasicMle::GetMediumSyncDelayTimer() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    return MicroSeconds(m_mediumSyncDelayInfo->mediumSyncDuration * 32);
+}
+
+void
+CommonInfoBasicMle::SetMediumSyncOfdmEdThreshold(int8_t threshold)
+{
+    NS_ABORT_MSG_IF(threshold < -72 || threshold > -62, "Threshold may range from -72 to -62 dBm");
+    uint8_t value = 72 + threshold;
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+    m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold = value;
+}
+
+int8_t
+CommonInfoBasicMle::GetMediumSyncOfdmEdThreshold() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    return (m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold) - 72;
+}
+
+void
+CommonInfoBasicMle::SetMediumSyncMaxNTxops(uint8_t nTxops)
+{
+    NS_ASSERT_MSG(nTxops < 16, "Value " << +nTxops << "cannot be encoded in 4 bits");
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+
+    if (nTxops == 0)
+    {
+        // no limit on max number of TXOPs
+        m_mediumSyncDelayInfo->mediumSyncMaxNTxops = 15;
+        return;
+    }
+
+    m_mediumSyncDelayInfo->mediumSyncMaxNTxops = --nTxops;
+}
+
+std::optional<uint8_t>
+CommonInfoBasicMle::GetMediumSyncMaxNTxops() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    uint8_t nTxops = m_mediumSyncDelayInfo->mediumSyncMaxNTxops;
+    if (nTxops == 15)
+    {
+        return std::nullopt;
+    }
+    return nTxops + 1;
+}
+
+} // namespace ns3
